>From d42fe72a5599cd0457fee5e3c8bbe3b894c3bdfc Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Sun, 13 May 2012 23:04:36 -0400
Subject: [PATCH] Adding restful interface to create certificate requests and
 issue certificates.

Refactored ProfileSubmitServlet to make the flow clearer.  Both the legacy servlets
and the new RESTful servlets use common ProfileProcessor objects that contain the main
business logic, so that the amount of duplicated code is minimized.

Refactored ProfileProcessServlet to use the new  common classes.
Addressed review comments. Removed an unneeded class and reverted some unneeded jaxb
annotations.  Added factory methods.
---
 .../netscape/cms/servlet/test/CARestClient.java    |   35 +-
 .../src/com/netscape/cms/servlet/test/CATest.java  |  166 ++-
 base/ca/shared/conf/CS.cfg.in                      |    9 +
 base/common/src/CMakeLists.txt                     |   21 +
 .../certsrv/base/BadRequestDataException.java      |   24 +
 .../com/netscape/certsrv/property/Descriptor.java  |   17 +
 .../com/netscape/certsrv/request/RequestId.java    |    4 +
 .../cms/servlet/base/CMSResourceService.java       |    4 +
 .../com/netscape/cms/servlet/base/CMSServlet.java  |    4 +
 .../netscape/cms/servlet/cert/CertProcessor.java   |  351 +++++
 .../cms/servlet/cert/EnrollmentProcessor.java      |  205 +++
 .../cms/servlet/cert/RenewalProcessor.java         |  345 +++++
 .../cms/servlet/cert/RequestProcessor.java         |  475 ++++++
 .../cms/servlet/common/AuthCredentials.java        |    6 +-
 .../netscape/cms/servlet/common/ServletUtils.java  |   42 +
 .../netscape/cms/servlet/processors/Processor.java | 1259 ++++++++++++++++
 .../cms/servlet/profile/ProfileProcessServlet.java |  915 +-----------
 .../cms/servlet/profile/ProfileServlet.java        |   69 +
 .../cms/servlet/profile/ProfileSubmitServlet.java  | 1513 ++------------------
 .../servlet/profile/model/PolicyConstraint.java    |   73 +
 .../profile/model/PolicyConstraintFactory.java     |   42 +
 .../profile/model/PolicyConstraintValue.java       |   61 +
 .../cms/servlet/profile/model/PolicyDefault.java   |   73 +
 .../profile/model/PolicyDefaultFactory.java        |   65 +
 .../servlet/profile/model/ProfileAttribute.java    |   80 ++
 .../cms/servlet/profile/model/ProfileData.java     |    1 +
 .../cms/servlet/profile/model/ProfileDataInfo.java |   10 +-
 .../cms/servlet/profile/model/ProfileInput.java    |    5 +
 .../servlet/profile/model/ProfileInputFactory.java |   40 +
 .../model/ProfileOutput.java}                      |   75 +-
 .../profile/model/ProfileOutputFactory.java        |   47 +
 .../cms/servlet/profile/model/ProfilePolicy.java   |   82 ++
 ...{ProfileDataInfo.java => ProfilePolicySet.java} |   56 +-
 .../cms/servlet/request/CertRequestResource.java   |   45 +-
 .../request/CertRequestResourceService.java        |  126 +-
 .../request/model/AgentEnrollmentRequestData.java  |  252 ++++
 .../model/AgentEnrollmentRequestDataFactory.java   |  174 +++
 .../cms/servlet/request/model/CMSRequestInfo.java  |   17 +
 .../cms/servlet/request/model/CertRequestDAO.java  |  165 ++-
 .../cms/servlet/request/model/CertRequestInfo.java |    1 +
 .../request/model/CertRequestInfoFactory.java      |   81 ++
 .../request/model/EnrollmentRequestData.java       |  143 +-
 .../model/EnrollmentRequestDataFactory.java        |   51 +
 43 files changed, 4737 insertions(+), 2492 deletions(-)
 create mode 100644 base/common/src/com/netscape/certsrv/base/BadRequestDataException.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/cert/CertProcessor.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/cert/RenewalProcessor.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/cert/RequestProcessor.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/processors/Processor.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraint.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraintFactory.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraintValue.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/PolicyDefault.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/PolicyDefaultFactory.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/ProfileAttribute.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/ProfileInputFactory.java
 copy base/common/src/com/netscape/cms/servlet/{request/model/CertRequestInfo.java => profile/model/ProfileOutput.java} (50%)
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/ProfileOutputFactory.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/profile/model/ProfilePolicy.java
 copy base/common/src/com/netscape/cms/servlet/profile/model/{ProfileDataInfo.java => ProfilePolicySet.java} (58%)
 create mode 100644 base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestData.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestDataFactory.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
 create mode 100644 base/common/src/com/netscape/cms/servlet/request/model/EnrollmentRequestDataFactory.java

diff --git a/base/ca/functional/src/com/netscape/cms/servlet/test/CARestClient.java b/base/ca/functional/src/com/netscape/cms/servlet/test/CARestClient.java
index 775c3d9b69b2bdbbf53c35ed9785705dfcad39a6..67138e52984536fd0ce34dcc45f8027432fe11fc 100644
--- a/base/ca/functional/src/com/netscape/cms/servlet/test/CARestClient.java
+++ b/base/ca/functional/src/com/netscape/cms/servlet/test/CARestClient.java
@@ -36,6 +36,7 @@ import com.netscape.cms.servlet.profile.model.ProfileData;
 import com.netscape.cms.servlet.profile.model.ProfileDataInfos;
 import com.netscape.cms.servlet.request.CertRequestResource;
 import com.netscape.cms.servlet.request.CertRequestsResource;
+import com.netscape.cms.servlet.request.model.AgentEnrollmentRequestData;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
 import com.netscape.cms.servlet.request.model.CertRequestInfos;
 import com.netscape.cms.servlet.request.model.EnrollmentRequestData;
@@ -104,7 +105,7 @@ public class CARestClient extends CMSRestClient {
 
     }
 
-    public CertRequestInfo enrollCertificate(EnrollmentRequestData data) {
+    public CertRequestInfos enrollCertificate(EnrollmentRequestData data) {
 
         if (data == null) {
             return null;
@@ -113,11 +114,41 @@ public class CARestClient extends CMSRestClient {
     }
 
     public CertRequestInfo getRequest(RequestId id) {
-
         if (id == null) {
             return null;
         }
         return certRequestClient.getRequestInfo(id);
     }
 
+    public AgentEnrollmentRequestData reviewRequest(RequestId id) {
+        if (id == null) {
+            return null;
+        }
+        return certRequestClient.reviewRequest(id);
+    }
+
+    public void approveRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.approveRequest(id, data);
+    }
+
+    public void rejectRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.rejectRequest(id, data);
+    }
+
+    public void cancelRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.cancelRequest(id, data);
+    }
+
+    public void updateRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.updateRequest(id, data);
+    }
+
+    public void validateRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.validateRequest(id, data);
+    }
+
+    public void unassignRequest(RequestId id, AgentEnrollmentRequestData data) {
+        certRequestClient.unassignRequest(id, data);
+    }
+
 }
diff --git a/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java b/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
index c3d55527ca030dc14049a5f1bed683690d20cd58..9afb1f38652947cc348730106745c0286c122efc 100644
--- a/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
+++ b/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
@@ -45,7 +45,9 @@ import com.netscape.cms.servlet.profile.model.ProfileDataInfo;
 import com.netscape.cms.servlet.profile.model.ProfileDataInfos;
 import com.netscape.cms.servlet.profile.model.ProfileInput;
 import com.netscape.cms.servlet.request.RequestNotFoundException;
+import com.netscape.cms.servlet.request.model.AgentEnrollmentRequestData;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
+import com.netscape.cms.servlet.request.model.CertRequestInfos;
 import com.netscape.cms.servlet.request.model.EnrollmentRequestData;
 
 public class CATest {
@@ -203,44 +205,20 @@ public class CATest {
 
         //Initiate a Certificate Enrollment
 
-        EnrollmentRequestData data = new EnrollmentRequestData();
-        data.setProfileId("caUserCert");
-        data.setIsRenewal(false);
+        EnrollmentRequestData data = createUserCertEnrollment();
+        enrollAndApproveCertRequest(client, data);
 
-        //Simulate a "caUserCert" Profile enrollment
+        // submit a RA authenticated user cert request
+        EnrollmentRequestData rdata = createRAUserCertEnrollment();
+        enrollCertRequest(client, rdata);
 
-        ProfileInput certReq = data.addInput("Key Generation");
-        certReq.setInputAttr("cert_request_type", "crmf");
-        certReq.setInputAttr(
-                "cert_request",
-                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz");
+        // now try a manually approved server cert
+        EnrollmentRequestData serverData = createServerCertEnrollment();
+        enrollAndApproveCertRequest(client,serverData);
 
-        ProfileInput subjectName = data.addInput("Subject Name");
-        subjectName.setInputAttr("sn_uid", "jmagne");
-        subjectName.setInputAttr("sn_e", "jmagne@redhat.com");
-        subjectName.setInputAttr("sn_c", "US");
-        subjectName.setInputAttr("sn_ou", "Development");
-        subjectName.setInputAttr("sn_ou1", "IPA");
-        subjectName.setInputAttr("sn_ou2", "Dogtag");
-        subjectName.setInputAttr("sn_ou3", "CA");
-        subjectName.setInputAttr("sn_cn", "Common");
-        subjectName.setInputAttr("sn_o", "RedHat");
-
-        ProfileInput submitter = data.addInput("Requestor Information");
-        submitter.setInputAttr("requestor_name", "admin");
-        submitter.setInputAttr("requestor_email", "admin@redhat.com");
-        submitter.setInputAttr("requestor_phone", "650-555-5555");
-
-        CertRequestInfo reqInfo = null;
-
-        try {
-            reqInfo = client.enrollCertificate(data);
-        } catch (Exception e) {
-            e.printStackTrace();
-            log(e.toString());
-        }
-
-        printRequestInfo(reqInfo);
+        // submit using an agent approval profile
+        serverData.setProfileId("caAgentServerCert");
+        enrollCertRequest(client, serverData);
 
         //Perform a sample certificate search with advanced search terms
 
@@ -293,6 +271,120 @@ public class CATest {
 
     }
 
+    private static void enrollAndApproveCertRequest(CARestClient client, EnrollmentRequestData data) {
+        CertRequestInfos reqInfo = null;
+        try {
+            reqInfo = client.enrollCertificate(data);
+        } catch (Exception e) {
+            e.printStackTrace();
+            log(e.toString());
+        }
+
+        for (CertRequestInfo info : reqInfo.getRequests()) {
+            printRequestInfo(info);
+
+            AgentEnrollmentRequestData reviewData = client.reviewRequest(info.getRequestId());
+            log(reviewData.toString());
+
+            reviewData.setRequestNotes("This is an approval message");
+            client.approveRequest(reviewData.getRequestId(), reviewData);
+        }
+    }
+
+    private static void enrollCertRequest(CARestClient client, EnrollmentRequestData data) {
+        CertRequestInfos reqInfo = null;
+        try {
+            reqInfo = client.enrollCertificate(data);
+        } catch (Exception e) {
+            e.printStackTrace();
+            log(e.toString());
+        }
+
+        for (CertRequestInfo info : reqInfo.getRequests()) {
+            printRequestInfo(info);
+        }
+    }
+
+    private static EnrollmentRequestData createUserCertEnrollment() {
+        EnrollmentRequestData data = new EnrollmentRequestData();
+        data.setProfileId("caUserCert");
+        data.setIsRenewal(false);
+
+        //Simulate a "caUserCert" Profile enrollment
+
+        ProfileInput certReq = data.createInput("Key Generation");
+        certReq.setInputAttr("cert_request_type", "crmf");
+        certReq.setInputAttr(
+                "cert_request",
+                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz");
+
+        ProfileInput subjectName = data.createInput("Subject Name");
+        subjectName.setInputAttr("sn_uid", "jmagne");
+        subjectName.setInputAttr("sn_e", "jmagne@redhat.com");
+        subjectName.setInputAttr("sn_c", "US");
+        subjectName.setInputAttr("sn_ou", "Development");
+        subjectName.setInputAttr("sn_ou1", "IPA");
+        subjectName.setInputAttr("sn_ou2", "Dogtag");
+        subjectName.setInputAttr("sn_ou3", "CA");
+        subjectName.setInputAttr("sn_cn", "Common");
+        subjectName.setInputAttr("sn_o", "RedHat");
+
+        ProfileInput submitter = data.createInput("Requestor Information");
+        submitter.setInputAttr("requestor_name", "admin");
+        submitter.setInputAttr("requestor_email", "admin@redhat.com");
+        submitter.setInputAttr("requestor_phone", "650-555-5555");
+        return data;
+    }
+
+    private static EnrollmentRequestData createRAUserCertEnrollment() {
+        EnrollmentRequestData data = new EnrollmentRequestData();
+        data.setProfileId("caDualRAuserCert");
+        data.setIsRenewal(false);
+
+        //Simulate a "caUserCert" Profile enrollment
+
+        ProfileInput certReq = data.createInput("Key Generation");
+        certReq.setInputAttr("cert_request_type", "crmf");
+        certReq.setInputAttr(
+                "cert_request",
+                "MIIB5DCCAeAwggFGAgQTosnaMIIBB4ABAqVOMEwxETAPBgNVBAMTCGFsZWUgcmEzMR4wHAYJKoZIhvcNAQkBFg9hbGVlQHJlZGhhdC5jb20xFzAVBgoJkiaJk/IsZAEBEwdhbGVlcmEzpoGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCkQh3k+1323YgQD+oA9yzftqxbGQlsbz0f2OEeOL5h0uhg/qPlSNMjRN3mAeuaNyF0n/Bdxv4699gRTsyEaVJu7HX+kauSCZv+J0tvHiYuHQz1/TSscU9TNLyQjgXVKQFHEdjZa2cQNdmMDUFWrftAK6BFnsP3Tu712qZPAuBH9QIDAQABqRAwDgYDVR0PAQH/BAQDAgXgMDMwFQYJKwYBBQUHBQEBDAhyZWdUb2tlbjAaBgkrBgEFBQcFAQIMDWF1dGhlbnRpY2F0b3KhgZMwDQYJKoZIhvcNAQEFBQADgYEATNi3vMxn9KMto999sR4ik851jqbb6L0GL1KKgQ/hjIAACQb2H+0OpqeZ2+DcGd+oAQn1YZe8aPoFu+HOWjHlY1E2tm7TI1B6JpCL3TMag3mYryROX7l7LFEa1P730aGOWJF874bG8UWisU190zhCBQUqUjsd9DwaP42qM0gnzas=");
+
+        ProfileInput subjectName = data.createInput("Subject Name");
+        subjectName.setInputAttr("sn_uid", "aleera3");
+        subjectName.setInputAttr("sn_e", "alee@redhat.com");
+        subjectName.setInputAttr("sn_cn", "alee ra3");
+
+        ProfileInput submitter = data.createInput("Requestor Information");
+        submitter.setInputAttr("requestor_name", "admin");
+        submitter.setInputAttr("requestor_email", "admin@redhat.com");
+        submitter.setInputAttr("requestor_phone", "650-555-1234");
+        return data;
+    }
+
+    private static EnrollmentRequestData createServerCertEnrollment() {
+        EnrollmentRequestData data = new EnrollmentRequestData();
+        data.setProfileId("caServerCert");
+        data.setIsRenewal(false);
+
+        //Simulate a "caUserCert" Profile enrollment
+
+        ProfileInput certReq = data.createInput("Key Generation");
+        certReq.setInputAttr("cert_request_type", "pkcs10");
+        certReq.setInputAttr(
+                "cert_request",
+                "MIIBZjCB0AIBADAnMQ8wDQYDVQQKEwZyZWRoYXQxFDASBgNVBAMTC2FsZWUtd29ya3BjMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDJtuKg9osJEBUwz8LoMQwwm1m7D97NNJEmvEhvBMet+VCtbd/erAFMoVXEgSKks/XFK2ViTeZYpp0A2pe4bm4yxowZm0b6von9BKGQ0jNtLemoOkGRWC/PP+fYP16aH62xu4z8MH1pBubdlAEp3Ppnr93aB1lzQaPVmcR3B4OWhwIDAQABoAAwDQYJKoZIhvcNAQEFBQADgYEAgZhZOe0LqQD5iywAO7sY0PANVGzzdcmoLZJjjASY3kU5E3K8u3FKh24WJxcWzdC+/FysDkJixJb7xGUm697QwZvGxmAIQH4yIebWJ2KLHQQgRJytjVYySrRo2Fuo/dm2zzf3+o8WBuD2eMsEjsZfuKxhz7EahvyC2y/CuTBA08s="
+        );
+        ProfileInput subjectName = data.createInput("Subject Name");
+        subjectName.setInputAttr("sn_cn", "alee-workpc");
+        subjectName.setInputAttr("sn_o", "redhat");
+
+        ProfileInput submitter = data.createInput("Requestor Information");
+        submitter.setInputAttr("requestor_name", "admin");
+        submitter.setInputAttr("requestor_email", "admin@redhat.com");
+        submitter.setInputAttr("requestor_phone", "650-555-5555");
+        return data;
+    }
+
     private static void printProfileInfos(ProfileDataInfos pInfos) {
 
         if (pInfos == null) {
@@ -451,11 +543,11 @@ public class CATest {
         }
 
         log("CertRequestURL: " + info.getRequestURL());
-        log("CertId: " +         info.getCertId());
+        log("CertId: " + ((info.getCertId() != null) ? info.getCertId() : ""));
         log("RequestType: " + info.getCertRequestType());
         log("Status:        " + info.getRequestStatus());
         log("Type:          " + info.getRequestType());
-        log("CertURL: "     + info.getCertURL() + "\n");
+        log("CertURL: " + ((info.getCertURL() != null) ? info.getCertURL(): "") + "\n");
     }
 
     private static void log(String string) {
diff --git a/base/ca/shared/conf/CS.cfg.in b/base/ca/shared/conf/CS.cfg.in
index ada97c4fadbe255f15d87ce6319a901d1737b25b..527de831d0978f87950a99bee0e16dd3a51953b6 100644
--- a/base/ca/shared/conf/CS.cfg.in
+++ b/base/ca/shared/conf/CS.cfg.in
@@ -1056,6 +1056,15 @@ profile.caEncUserCert.config=[PKI_INSTANCE_PATH]/profiles/ca/caEncUserCert.cfg
 profile.caEncECUserCert.class_id=caEnrollImpl
 profile.caEncECUserCert.config=[PKI_INSTANCE_PATH]/profiles/ca/caEncECUserCert.cfg
 registry.file=[PKI_INSTANCE_PATH]/conf/registry.cfg
+profile.caProfileProcess.getClientCert=true
+profile.caProfileProcess.authzMgr=BasicAclAuthz
+profile.caProfileProcess.authorityId=ca
+profile.caProfileProcess.authzResourceName=certServer.ca.request.profile
+profile.caProfileProcess.authMgr=certUserDBAuthMgr
+profile.caProfileSubmit.authorityId=ca
+profile.caProfileSubmit.authzMgr=BasicAclAuthz
+profile.caProfileSubmit.authzResourceName=certServer.ee.profile
+profile.caProfileSubmit.getClientCert=false
 request.assignee.enable=true
 selftests._000=##
 selftests._001=## Self Tests
diff --git a/base/common/src/CMakeLists.txt b/base/common/src/CMakeLists.txt
index 7b73a8536c1c282e3491122f148cea456cbc4603..6d8386faf2f1aedd0bb4fecead3a4aa124be8307 100644
--- a/base/common/src/CMakeLists.txt
+++ b/base/common/src/CMakeLists.txt
@@ -251,6 +251,7 @@ set(pki-certsrv_java_SRCS
     com/netscape/certsrv/base/IAttrSet.java
     com/netscape/certsrv/base/ICRLPrettyPrint.java
     com/netscape/certsrv/base/ICertPrettyPrint.java
+    com/netscape/certsrv/base/BadRequestDataException.java
     com/netscape/certsrv/dbs/IDBRegistry.java
     com/netscape/certsrv/dbs/IDBAttrMapper.java
     com/netscape/certsrv/dbs/IElementProcessor.java
@@ -614,6 +615,10 @@ set(pki-cms_java_SRCS
     com/netscape/cms/servlet/cert/CertResourceService.java
     com/netscape/cms/servlet/cert/CertsResource.java
     com/netscape/cms/servlet/cert/CertsResourceService.java
+    com/netscape/cms/servlet/cert/RequestProcessor.java
+    com/netscape/cms/servlet/cert/CertProcessor.java
+    com/netscape/cms/servlet/cert/EnrollmentProcessor.java
+    com/netscape/cms/servlet/cert/RenewalProcessor.java
     com/netscape/cms/servlet/cert/model/CertificateData.java
     com/netscape/cms/servlet/cert/model/CertDAO.java
     com/netscape/cms/servlet/cert/model/CertDataInfo.java
@@ -746,6 +751,7 @@ set(pki-cms_java_SRCS
     com/netscape/cms/servlet/processors/CRMFProcessor.java
     com/netscape/cms/servlet/processors/IPKIProcessor.java
     com/netscape/cms/servlet/processors/CMCProcessor.java
+    com/netscape/cms/servlet/processors/Processor.java
     com/netscape/cms/servlet/request/ProcessReq.java
     com/netscape/cms/servlet/request/CheckRequest.java
     com/netscape/cms/servlet/request/IReqParser.java
@@ -776,8 +782,12 @@ set(pki-cms_java_SRCS
     com/netscape/cms/servlet/request/model/CertRequestInfo.java
     com/netscape/cms/servlet/request/model/CertRequestInfos.java
     com/netscape/cms/servlet/request/model/CertRetrievalRequestData.java
+    com/netscape/cms/servlet/request/model/AgentEnrollmentRequestData.java 
     com/netscape/cms/servlet/request/model/EnrollmentRequestData.java 
     com/netscape/cms/servlet/request/model/ProfileRetrievalRequestData.java
+    com/netscape/cms/servlet/request/model/AgentEnrollmentRequestDataFactory.java
+    com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
+    com/netscape/cms/servlet/request/model/EnrollmentRequestDataFactory.java
     com/netscape/cms/servlet/tks/TokenServlet.java
     com/netscape/cms/servlet/connector/CloneServlet.java
     com/netscape/cms/servlet/connector/TokenKeyRecoveryServlet.java
@@ -809,6 +819,17 @@ set(pki-cms_java_SRCS
     com/netscape/cms/servlet/profile/model/ProfileDataInfo.java
     com/netscape/cms/servlet/profile/model/ProfileDataInfos.java
     com/netscape/cms/servlet/profile/model/ProfileInput.java
+    com/netscape/cms/servlet/profile/model/ProfileAttribute.java
+    com/netscape/cms/servlet/profile/model/PolicyConstraint.java
+    com/netscape/cms/servlet/profile/model/PolicyConstraintValue.java
+    com/netscape/cms/servlet/profile/model/PolicyDefault.java
+    com/netscape/cms/servlet/profile/model/ProfileInput.java
+    com/netscape/cms/servlet/profile/model/ProfilePolicy.java
+    com/netscape/cms/servlet/profile/model/ProfilePolicySet.java
+    com/netscape/cms/servlet/profile/model/PolicyConstraintFactory.java
+    com/netscape/cms/servlet/profile/model/PolicyDefaultFactory.java
+    com/netscape/cms/servlet/profile/model/ProfileInputFactory.java
+    com/netscape/cms/servlet/profile/model/ProfileOutputFactory.java
     com/netscape/cms/authentication/AgentCertAuthentication.java
     com/netscape/cms/authentication/PortalEnroll.java
     com/netscape/cms/authentication/UdnPwdDirAuthentication.java
diff --git a/base/common/src/com/netscape/certsrv/base/BadRequestDataException.java b/base/common/src/com/netscape/certsrv/base/BadRequestDataException.java
new file mode 100644
index 0000000000000000000000000000000000000000..268221eae726ed93b37d08e3ae721ace3340a43d
--- /dev/null
+++ b/base/common/src/com/netscape/certsrv/base/BadRequestDataException.java
@@ -0,0 +1,24 @@
+package com.netscape.certsrv.base;
+
+public class BadRequestDataException extends EBaseException {
+
+    private static final long serialVersionUID = -8401421856920994265L;
+
+
+    public BadRequestDataException(String msgFormat) {
+        super(msgFormat);
+    }
+
+    public BadRequestDataException(String msgFormat, Exception param) {
+        super(msgFormat, param);
+    }
+
+    public BadRequestDataException(String msgFormat, Object[] params) {
+        super(msgFormat, params);
+    }
+
+    public BadRequestDataException(String msgFormat, String param) {
+        super(msgFormat, param);
+    }
+
+}
diff --git a/base/common/src/com/netscape/certsrv/property/Descriptor.java b/base/common/src/com/netscape/certsrv/property/Descriptor.java
index 4b2baf5611edf9a9d0566626d59f4223e9132f61..d3048e0b9b8be0371044d9c208dce3f06cb8767d 100644
--- a/base/common/src/com/netscape/certsrv/property/Descriptor.java
+++ b/base/common/src/com/netscape/certsrv/property/Descriptor.java
@@ -19,12 +19,19 @@ package com.netscape.certsrv.property;
 
 import java.util.Locale;
 
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlRootElement;
+
+
 /**
  * This interface represents a property descriptor. A descriptor
  * includes information that describe a property.
  *
  * @version $Revision$, $Date$
  */
+@XmlRootElement
+@XmlAccessorType(XmlAccessType.FIELD)
 public class Descriptor implements IDescriptor {
 
     protected String mSyntax = null;
@@ -32,6 +39,10 @@ public class Descriptor implements IDescriptor {
     protected String mDescription = null;
     protected String mDef = null;
 
+    public Descriptor() {
+        // required for JAX-B
+    }
+
     /**
      * Constructs a descriptor.
      *
@@ -90,4 +101,10 @@ public class Descriptor implements IDescriptor {
     public String getDescription(Locale locale) {
         return mDescription;
     }
+
+    @Override
+    public String toString() {
+        return "Descriptor [mSyntax=" + mSyntax + ", mConstraint=" + mConstraint + ", mDescription=" + mDescription
+                + ", mDef=" + mDef + "]";
+    }
 }
diff --git a/base/common/src/com/netscape/certsrv/request/RequestId.java b/base/common/src/com/netscape/certsrv/request/RequestId.java
index 795fdaa2abadb871a832b6978c41e911f8405aee..8cd8c5711dde2219fec95cf517e2e5658f7980fc 100644
--- a/base/common/src/com/netscape/certsrv/request/RequestId.java
+++ b/base/common/src/com/netscape/certsrv/request/RequestId.java
@@ -31,6 +31,10 @@ public class RequestId {
 
     protected BigInteger value;
 
+    public RequestId() {
+        // required for jaxb
+    }
+
     /**
      * Creates a new RequestId from its string representation.
      * <p>
diff --git a/base/common/src/com/netscape/cms/servlet/base/CMSResourceService.java b/base/common/src/com/netscape/cms/servlet/base/CMSResourceService.java
index 85ccbf9f7100e2e8768129b470721491ddf53713..d6b4a9e42605a394bcf42bdecc59e54c12f0b3c6 100644
--- a/base/common/src/com/netscape/cms/servlet/base/CMSResourceService.java
+++ b/base/common/src/com/netscape/cms/servlet/base/CMSResourceService.java
@@ -24,6 +24,7 @@ import java.util.List;
 import java.util.Locale;
 import java.util.Map;
 
+import javax.servlet.http.HttpServletRequest;
 import javax.ws.rs.FormParam;
 import javax.ws.rs.core.CacheControl;
 import javax.ws.rs.core.Context;
@@ -62,6 +63,9 @@ public class CMSResourceService {
     @Context
     protected Request request;
 
+    @Context
+    protected HttpServletRequest servletRequest;
+
     public ILogger logger = CMS.getLogger();
     public IAuditor auditor = CMS.getAuditor();
 
diff --git a/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java b/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
index 1c610996f4dd251b0ef557e6ab0de69a7b8e7c35..f035285e2f31063ebfa417e955154d9d42ec689b 100644
--- a/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
+++ b/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
@@ -117,6 +117,7 @@ public abstract class CMSServlet extends HttpServlet {
 
     public final static String PROP_ID = "ID";
     public final static String PROP_AUTHORITY = "authority";
+    public final static String PROP_AUTHORITYID = "authorityId";
     public final static String PROP_AUTHMGR = "AuthMgr";
     public final static String PROP_CLIENTAUTH = "GetClientCert";
     public final static String PROP_RESOURCEID = "resourceID";
@@ -291,6 +292,9 @@ public abstract class CMSServlet extends HttpServlet {
         mOutputTemplatePath = sc.getInitParameter("templatePath");
 
         String authority = sc.getInitParameter(PROP_AUTHORITY);
+        if (authority == null) {
+            authority = sc.getInitParameter(PROP_AUTHORITYID);
+        }
 
         if (authority != null)
             mAuthority = (IAuthority)
